// Kingdom of Kod
// ==============
// -Adventures of the heroes in the 'Manga Guide to Databases'

// -Filename: Named_3D.hpp
// -

#pragma once

#include "common_incls.hpp"

class Named_3D {
 public:
  Named_3D();

  /** @return the item's common name */
  auto name() const noexcept -> decltype(std::string{});
  /** Assign the item's common name
   * @param name [I] - the name to use */
  void name(std::string const& name) noexcept;

  // /** @return the item's common type tag */
  auto type_tag() const noexcept -> decltype(std::string{});
  /** Assign the item's common type tag
   * @param type_tag [I] - the type tag to use */
  void type_tag(std::string const& type_tag) noexcept;

  /** @return the item's 3D position */
  auto posn() const noexcept -> decltype(Posn{});
  /** Assign the item's 3D position
   * @param x
   * @param y
   * @param z */
  void posn(double const x, double const y, double const z) noexcept;

 private:
  string name_;
  string type_tag_;
  Posn   posn_;
};

// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
