// Kingdom of Kod
// ==============
// -Adventures of the heroes in the 'Manga Guide to Databases'

// -Filename: Posn.hpp
// -

// TODO DESIGN: eventually just use this as wrapper for a 'Geom::Point' instead?

#include <iostream>

/** A 3-dimensional coordinate in Cartesian space */
struct Posn {
  double x{0.0}, y{0.0}, z{0.0};

  Posn(){};
  Posn(double const x, double const y, double const z) : x{x}, y{y}, z{z} {};

  // DESIGN: just replace this with an 'operator=()' ?
  void assign(double const x_, double const y_, double const z_) {
    x = x_;
    y = y_;
    z = z_;
  }

  /** Posn coordinates stream insertion operator; appends these 3D-coordinates
   * into the referenced output stream
   *
   * @param   os [I/O] is mutated by appending the coordinates
   * @param posn [I] effectively a const& (*this) reference
   * @return the (now-modified) output stream reference
   *
   * @a example
   * <code>cout << type_tag << ".posn(): '" << item.posn() << "'\n";</code>
   *
   * @b ref'd: Named_3D::posn() */
  friend std::ostream& operator<<(std::ostream& os, Posn const& posn) {
    os << ' ' << posn.x << ' ' << posn.y << ' ' << posn.z << ' ';
    return os;
  }

  friend bool operator==(Posn const& lhs, Posn const& rhs) {
    // DESIGN: add an Epsilon factor?
    return (lhs.x == rhs.x) && (lhs.y == rhs.y) && (lhs.z == rhs.z);
  }
};

// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
