// Kingdom of Kod
// ==============
// -Adventures of the heroes in the 'Manga Guide to Databases'

// -Filename: main.cpp
// -The program's entry point, and some basic tests of overall architecture

/*
So for now, this is just a basic proof-of-concept for a system to support Anon's
ideas around robowaifu's information access-control systems. If things proceed
apace, then eventually this should finally be an interim working expression of
the custom /robowaifu/ 'waifu animation and simulation' system begun long ago.

It's unclear yet just how far to go specifically, since ATM this is primarily to
eventually support a different, testbed, project. Still, the intent has been
around for several years along with the prior works, so it's likely this will
turn into a primary effort after several revisions. In particular, probably some
variant of the former robowaifu code that was developed over 5 years ago will be
adopted, or it's architectural paradigms revisited at the very least. Even some
of our _older_ (4/g/) works may be re-conceived here who knows? Time will tell.

Certainly the general work is well outside the silly namesake title adopted in
this current effort. Probably just some kind of an homage to the fairybot
robowaifu work begun by Anon in his thread during the first year of the board.

DESIGN GOALS:
=============

-Primarily, to flesh out a screenplay scripting, animation, natural interaction,
AI-inferencing, etc., system. For this effort, the ''Manga Guide to Databases''
characters, scenarios, and topics act as inspiration and guidance.

  -Characters
  -Layouts
  -Props
  -Environments, Lighting, and Effects
  -Mesh generation for Blender
  -Automated CV-based sourcing for character designs directly from the manga
  -Properly-formatted script generation
  -Integrate with the RW Simulator or some other animation visualization system

-Secondarily, a few technical design goals currently center around devising a
JSON-based SQL database system to use with other projects, such as the robowaifu
access-control AI project, and the later form of the RW simulation system.

  -Use JSON as the data system
  -Support BSON binary loading & storage
  -Support direct system streams via standard C++ insertion/extraction operators
  -Maintain an even more natural interface than the 4G language can provide
  -Search for even more compact data representations for embedded platforms

-There will obviously be new goals that develop during the progress with the
current effort, as 'new vistas yet-unexplored' open up before the adventurers
themselves. Let us go forth afield & see what profound truths they uncover! :^)

-Book sauce:

  https://nostarch.com/mg_databases.htm
*/

#include <iostream>

#include "Named_3D.hpp"

#include "rw_cli_args.hpp"

using std::cout;

/**-----------------------------------------------------------------------------
 * The program's entry point
 *
 * @param argc [I] the CLI arguments count
 * @param argv [I] the CLI arguments C-string array
 * @return the program's exit status back to the system; success code == 0
 *
 * @a example
 * <code># kingdom_of_kod --a_made_up_flag foo -b "bar" --baz 42</code>
 *
 * TODO: replace toy code example here once program's args are well-established
 */
int main(int argc, char** argv) {
  rw::parse_args(argc, argv);

  cout << "Hello Anon, from the Kingdom of Kod!\n";
}

// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
